#include "main_sram.h"

void main (void)
{
    init();

    bool result_walk_data_zero    = false;
    bool result_walk_data_one     = false;
    bool result_walk_address_zero = false;
    bool result_walk_address_one  = false;
    bool result_byte_enable       = false;

    ioport_set_value( ioport, 0, 0 );
    ioport_set_value( ioport, 1, 0 );
    ioport_set_value( ioport, 2, 0 );

    ioport_set_value( ioport, 0, 0x01 );
    delay_ms( 1000 );


//    ioport_set_value( ioport, 2, LED_TEST1 );
    result_walk_data_zero    = test_memory_walk_data(Base_XRAM, Size_XRAM, e_walk_data_zero);

    if (!result_walk_data_zero)
    {
       ioport_set_value( ioport, 1, 0x01 );
    }

    ioport_set_value( ioport, 0, 0x02 );
    delay_ms( 1000 );

//    ioport_set_value( ioport, 2, LED_TEST2 );
    result_walk_data_one     = test_memory_walk_data(Base_XRAM, Size_XRAM, e_walk_data_one);

    if (!result_walk_data_one)
    {
       ioport_set_value( ioport, 1, 0x02 );
    }

    ioport_set_value( ioport, 0, 0x04 );
    delay_ms( 1000 );


//    ioport_set_value( ioport, 2, LED_TEST3 );
    result_walk_address_zero = test_memory_walk_address_zero(Base_XRAM, Size_XRAM);

    if (!result_walk_address_zero)
    {
       ioport_set_value( ioport, 1, 0x04 );
    }

    ioport_set_value( ioport, 0, 0x08 );
    delay_ms( 1000 );
//    ioport_set_value( ioport, 2, LED_TEST4 );
    result_walk_address_one  = test_memory_walk_address_one(Base_XRAM, Size_XRAM);

    if (!result_walk_address_one)
    {
       ioport_set_value( ioport, 1, 0x08 );
    }

    ioport_set_value( ioport, 0, 0x10 );
    delay_ms( 1000 );

//    ioport_set_value( ioport, 2, LED_TEST5 );
    result_byte_enable       = test_memory_byte_enable(Base_XRAM, Size_XRAM);


    if (!result_walk_address_one)
    {
       ioport_set_value( ioport, 1, 0x10 );
    }

    ioport_set_value( ioport, 0, 0x20 );
    delay_ms( 1000 );

    if (!result_walk_data_zero | !result_walk_data_one | !result_walk_address_zero | !result_walk_address_one | !result_byte_enable)
    {
        display_results( 1 );
    } else {
        display_results( 0 );
    }
}

void init( void )
{
    ioport = ioport_open( DRV_IOPORT_1 );
    ioport_set_value( ioport, 0, 0 );
    ioport_set_value( ioport, 1, 0 );
    ioport_set_value( ioport, 2, 0xFF );  // test is running - RGB_B on
    ioport_set_value( ioport, 3, 0 );
}

void display_results( uint32_t error_count )
{
    ioport_set_value( ioport, 0, 0 );
    ioport_set_value( ioport, 1, 0 );
    ioport_set_value( ioport, 2, 0 );
    if ( error_count == 0 )
    {
        while( 1 )
        {
            ioport_set_value( ioport, 0, 0x0F );
            delay_ms( 200 );
            ioport_set_value( ioport, 0, 0xF0 );
            delay_ms( 200 );
        }
    }
    else
    {
        while( 1 )
        {
            ioport_set_value( ioport, 1, 0x00 );
            delay_ms( 200 );
            ioport_set_value( ioport, 1, 0xFF );
            delay_ms( 200 );
        }
    }
}
